Attribute VB_Name = "Wiring"
Option Explicit


Global Const SELECTED = 1  'Things / Groups status
Global Const HIDDEN = 2
Global Const CUT = 4
Global Const COPIED = 8
Global Const DELETED = 16

Global LinksColor As Long
Global LinkSelColor As Long

Global FlyingGroup As Integer
Global PointedSaId As Integer
Global FGOrgX As Integer        'Initial locations
Global FGOrgY As Integer
Global FGDX As Integer          'Curent offsets
Global FGDY As Integer

Global Selecteds() As Integer
Global Rejecteds() As Integer
Global SelectsCount As Integer
Global RejectsCount As Integer
Global GridOn As Boolean
Global GridPitch As Single
Global Const GridAspect = 1
Global Find As Boolean
Global Doing As String
Global Drawing As String
Global Thickness As Single
Global KZoom As Single
Global ScaleText As Single
Global XZoom As Single
Global YZoom As Single
Global Zooming As Boolean
Global Grouping As Boolean
Global LMX As Single        'Mouse pointer position
Global LMY As Single
Global CMP As Boolean       'State of the custom mouse pointer
Global OX As Single         'X offset of the left most point
Global OY As Single         'Y offset of the top most point
Global Hradius As Single    'Used to draw circle, elipse or arc
Global Vradius As Single
Global ArcStart As Single
Global ArcEnd As Single

Type CXY
    Id As Integer
    X1 As Single
    Y1 As Single
    X2 As Single
    Y2 As Single
    Status As Integer
End Type

Type Thing          'A drawable thing
    What As String  'Can be a point, a line, a rectangle, a text or an arc: P, L, R, T, A
    T As Single     'Thickness or size for text
    BegX As Single  'Begin and End cordinates of this thing, the center of a circle.
    BegY As Single
    EndX As Single  'Radius for circle
    EndY As Single  'Aspect for an elipse
    ArcS As Single  'Start for an arc
    ArcE As Single  'End for an arc
    Color As Long
    Txt As String
    Status As Integer
End Type

Type ThingIds   'The group and thing Ids
    G As Integer
    T As Integer
End Type

'Type Node
'    G As Integer    'The group to wich it belongs
'    T As Integer    'It's identifier
'    SA   As CXY     'Selectable
'End Type

Type Group              'A group of things
    Typ As String
    Things() As Thing   'Grouped things
    ThingsCount As Integer
    Nodes() As CXY
    NodesCount As Integer
    NodeCorner As Integer
'    DX As Integer       'Where to draw it (relative to original things)
'    DY As Integer
    DX As Single       'Where to draw it (relative to original things)
    DY As Single
    SA As CXY           'Selectable area
    Status As Integer
    ''  How to have grouped text things with different contents ? By adding as many "private text things" as necessary !
End Type

Type SAC     'Copy of selected area to speed up search
    G As Integer    'Group
    T As Integer    'Type: 0 = Group, 1 = Node . . .
    N As Integer    'Node if applicable
    A As CXY        'Absolute area location
End Type

Type Link
    G1 As Integer
    N1 As Integer   'Node in the group to be linked with . . .
    G2 As Integer
    N2 As Integer   '. . . this one.
    Status As Integer
End Type

Global TempGroup As Group   'To edit a group
Global TempGid As Integer   'The group being edited
Global FreeTids() As Integer    'To recycle freed thing identifier
Global FreeTidsCount As Integer
Global FreeGids() As Integer    'To recycle freed group identifiers
Global FreeGidsCount As Integer
Global FreeNids() As Integer    'Freed node identifiers
Global FreeNidsCount As Integer
Global FreeLids() As Integer    'Freed link identifier
Global FreeLidsCount As Integer
Global Groups() As Group
Global GroupsCount As Integer
Global Links() As Link  'CXY
Global LinksCount As Integer
Global Sas() As SAC
Global SasCount As Integer
Global OrgDrawingX As Single
Global OrgDrawingY As Single
Global DestDrawingX As Single
Global DestDrawingY As Single

Public Sub PrepareRedimableArrays()
' Insure all redimensionable arrays exist
Dim I As Integer

    LinksColor = RGB(255, 0, 0)
    LinkSelColor = RGB(254, 254, 254)     'Almost white, expected barely visible ?
    
    SelectsCount = 0
    ReDim Selecteds(0)
    RejectsCount = 0
    ReDim Rejecteds(0)
    FreeTidsCount = 0
    ReDim FreeTids(0)
    FreeGidsCount = 0
    ReDim FreeGids(0)
    FreeNidsCount = 0
    ReDim FreeNids(0)
    FreeLidsCount = 0
    ReDim FreeNids(0)
    ReDim FreeLids(0)
    FreeLidsCount = 0
    If GroupsCount > 0 Then
        For I = 0 To GroupsCount
            Groups(I).ThingsCount = 0
            ReDim Groups(I).Things(0)
            Groups(I).NodesCount = 0
            ReDim Groups(I).Nodes(0)
        Next
    End If
    GroupsCount = 0
    ReDim Groups(0)
    LinksCount = 0
    ReDim Links(0)
    SasCount = 0
    ReDim Sas(0)
End Sub

Public Sub RedrawAll()
    
    Form1.P1CmdList.Visible = False
    Form1.P1.Cls
    DrawGroups
    DrawLinksA LinksColor, LinkSelColor
    DrawNodes
'    LoadDraw Substring(Fichier, 1, ".") & ".drw"
'    Form1.P1.SetFocus
End Sub


Public Function IsSelected(Gid As Integer, Tid As Integer) As Boolean

    IsSelected = (Groups(Gid).Status And SELECTED) Or (Groups(Gid).Things(Tid).Status And SELECTED)
End Function

Public Function IsHidden(Gid As Integer, Tid As Integer) As Boolean

    IsHidden = (Groups(Gid).Status And HIDDEN) Or (Groups(Gid).Things(Tid).Status And HIDDEN)
End Function

Public Function IsCut(Gid As Integer, Tid As Integer) As Boolean

    IsCut = (Groups(Gid).Status And CUT) Or (Groups(Gid).Things(Tid).Status And CUT)
End Function

Public Function IsCopied(Gid As Integer, Tid As Integer) As Boolean

    IsSCopied = (Groups(Gid).Status And COPIED) Or (Groups(Gid).Things(Tid).Status And COPIED)
End Function

Public Function IsDeleted(Gid As Integer, Tid As Integer) As Boolean

    IsDeleted = (Groups(Gid).Status And DELETED) Or (Groups(Gid).Things(Tid).Status And DELETED)
End Function

Public Sub SetStatus(Gid As Integer, Tid As Integer, Status As Integer)

    Groups(Gid).Things(Tid).Status = Groups(Gid).Things(Tid).Status Or Status
End Sub

Public Sub ReSetStatus(Gid As Integer, Tid As Integer, Status As Integer)

    Groups(Gid).Things(Tid).Status = Groups(Gid).Things(Tid).Status And Not Status
End Sub

Public Function GetStatus(Gid As Integer, Tid As Integer) As Integer
    
    GetStatus = Groups(Gid).Things(Tid).Status
End Function

Public Sub SaveDraw(File As String) 'Ignore deleted items
Dim I As Integer
Dim J As Integer
Dim S As String
Dim F As Integer
Dim Sep As String

    Sep = Chr(9)
    F = IsOpen(File, "W", 10)
    If F Then
        J = 0
        While J <= GroupsCount
            If Groups(J).Status = 0 Then    'not deleted
                S = "Group:" & Sep & str(J) & Sep & str(Groups(J).DX) & Sep _
                    & str(Groups(J).DY) & Sep & str(Groups(J).Status) & Sep _
                    & Groups(J).Typ & Sep & str(Groups(J).NodeCorner)
                Print #F, S
                S = "SelArea:" & Sep & str(Groups(J).SA.X1) & Sep _
                    & str(Groups(J).SA.X2) & Sep _
                    & str(Groups(J).SA.Y1) & Sep _
                    & str(Groups(J).SA.Y2)
                Print #F, S
                For I = 1 To Groups(J).ThingsCount      'for each thing in this group
                    With Groups(J).Things(I)
                        S = "Thing:" & Sep & str(I) & Sep & .What & Sep
                        S = S & str(.T) & Sep
                        S = S & str(.BegX) & Sep
                        S = S & str(.BegY) & Sep
                        S = S & str(.EndX) & Sep
                        S = S & str(.EndY) & Sep
                        S = S & str(.ArcS) & Sep
                        S = S & str(.ArcE) & Sep
                        S = S & str(.Color) & Sep
                        S = S & .Txt & Sep
                    End With
                    Print #F, S
                Next
'                Print #F, ""   'Blank line between bloc for human readability
                For I = 1 To Groups(J).NodesCount       'for each node
                    With Groups(J).Nodes(I)
                        S = "Node:" & Sep & str(I) & Sep & str(.X1) & Sep & str(.X2) & Sep & str(.Y1) & Sep & str(.Y2)
                    End With
                    Print #F, S
                Next
'                Print #F, ""
            End If
            J = J + 1
            Print #F, "------------------------------------------------------"
        Wend
        For J = 1 To LinksCount
            With Links(J)
                If Links(J).Status = 0 Then
                    S = "Links:" & Sep & str(J) & Sep & str(.G1) & Sep & str(.N1) & Sep & str(.G2) & Sep & str(.N2)
                    Print #F, S
                End If
            End With
        Next
        XClose F, 10
    End If
End Sub
Public Sub LoadDraw(File As String)
' Add to current drawing
Dim F As Integer
Dim S As String
Dim Gid As Integer
Dim Sep As String
Dim Gnum As Integer
Dim Glist(1000) As Integer  'This limits number of groups to 1000
'Dim G1 As Integer
'Dim G2 As Integer

    Sep = Chr(9)
    F = IsOpen(File, "R", 10)
    If F Then
'        If Add Then PrepareRedimableArrays 'Do that before call to replace all groups
        Do While Not EOF(F)
            Line Input #F, S    'TODO: Allows comments
            S = Trim(S)     'remove leading white
            If Len(S) Then  'Ignore empty lines
                Select Case Substring(S, 1, Sep)
                Case "Group:"
                    If Val(Substring(S, 2, Sep)) > 0 Then
                        Gid = NewGroup
                        Glist(Gid) = Val(Substring(S, 2, Sep))  'To remap links
                        With Groups(Gid)
                            .DX = Val(Substring(S, 3, Sep))
                            .DY = Val(Substring(S, 4, Sep))
                            .Typ = Substring(S, 6, Sep)
                            .NodeCorner = Val(Substring(S, 7, Sep))
                            .Status = 0
                        End With
                    End If
                Case "SelArea:"
                    SetSa Gid, Val(Substring(S, 2, Sep)), Val(Substring(S, 3, Sep)) _
                        , Val(Substring(S, 4, Sep)), Val(Substring(S, 5, Sep))
                Case "Thing:"
                    NewThing Substring(S, 3, Sep), Val(Substring(S, 4, Sep)) _
                        , Val(Substring(S, 11, Sep)), Val(Substring(S, 5, Sep)) _
                        , Val(Substring(S, 6, Sep)), Val(Substring(S, 7, Sep)) _
                        , Val(Substring(S, 8, Sep)), Substring(S, 12, Sep), Gid
                Case "Node:"
                    MakeNode Gid, Val(Substring(S, 3, Sep)), Val(Substring(S, 5, Sep))
                Case "Links:"
'                    G1 = Val(Substring(S, 3, Sep))
'                    G2 = Val(Substring(S, 5, Sep))
                    MakeLink GetIndex(Glist, Val(Substring(S, 3, Sep))), Val(Substring(S, 4, Sep)) _
                        , GetIndex(Glist, Val(Substring(S, 5, Sep))), Val(Substring(S, 6, Sep))
                End Select
            End If
        Loop
        XClose F, 10
'' remap links
    End If
    RedrawAll
End Sub
Private Function GetIndex(Tb() As Integer, Val As Integer) As Integer

    For GetIndex = 1 To UBound(Tb)
        If Tb(GetIndex) = Val Then Exit Function    'Found
    Next
    GetIndex = 0    'Not found
End Function

Public Sub DeleteAllGroups()

    GroupsCount = 0
    ReDim Groups(0)
End Sub

Public Function NewThing(What As String, Thick As Single, Color As Long, BX As Single, BY As Single, EX As Single, EY As Single, Txt As String, Optional Gid As Integer = 0) As ThingIds
''' Create a new Thing '''
'Everything is stored in a "Thing" object wich always belongs to a "Group" object.
'If Gid is not specified (or 0), Group 0 (already instanciated) is used
'If specified, a new group is created if necessary
''''''' Returns the identifier of this thing

Dim Id As Integer

    If Gid = -1 Then Gid = NewGroup 'Create one
    With Groups(Gid)
        If .ThingsCount = 0 Then ReDim .Things(10)    'Insure Things exists
        .ThingsCount = .ThingsCount + 1
        If .ThingsCount > UBound(.Things) Then ReDim Preserve .Things(.ThingsCount + 10) 'Add 10 entries at a time
        Id = .ThingsCount
    End With
    With Groups(Gid).Things(Id)
        .What = What
        .BegX = (BX + OX) / KZoom
        .BegY = (BY + OY) / KZoom
        .EndX = (EX + OX) / KZoom
        .EndY = (EY + OY) / KZoom
        .T = Thick
        .Color = Color
        .Txt = Txt
    End With
'    NewThing = ThingsCount
    NewThing.G = Gid
    NewThing.T = Id
End Function

Public Function MakeNode(G As Integer, X As Single, Y As Single) As Integer
'Add a connection point in this group

    If G = 0 Then Exit Function
    With Groups(G)
        .NodesCount = .NodesCount + 1
        If .NodesCount > UBound(.Nodes) Then ReDim Preserve .Nodes(.NodesCount + 10)  'Extend array
        MakeNode = .NodesCount
        .Nodes(MakeNode).X1 = X
        .Nodes(MakeNode).X2 = X
        .Nodes(MakeNode).Y1 = Y
        .Nodes(MakeNode).Y2 = Y
        .Nodes(MakeNode).Id = MakeNode
    End With
'    NewThing "P", 2.5, RGB(0, 0, 255), X, Y, X, Y, "", G    'Show it for debug
'' can be shown latter when it's place will be known with something like "DrawNodes" ''
End Function

Public Function MakeLink(G1 As Integer, N1 As Integer, G2 As Integer, N2 As Integer) As Integer
'Links two connection points
Dim Lid As Integer

    If G1 = 0 Or N1 = 0 Or G2 = 0 Or N2 = 0 Then Exit Function
    If FreeLidsCount > 0 Then 'Recycle
        Lid = FreeLids(FreeLidsCount)
        FreeLidsCount = FreeLidsCount - 1
    Else
        LinksCount = LinksCount + 1
        If LinksCount > UBound(Links) Then ReDim Preserve Links(LinksCount + 10) 'Expand array if needed
        Lid = LinksCount
    End If
    MakeLink = Lid
    With Links(Lid)
        .G1 = G1
        .N1 = N1
        .G2 = G2
        .N2 = N2
        .Status = 0
    End With
End Function

Public Sub DrawLinkA(Link As Integer, Color As Long, SelColor As Long)

Dim G1 As Integer
Dim G2 As Integer
Dim N1 As Integer
Dim N2 As Integer

Dim X1 As Single
Dim X2 As Single
Dim Y1 As Single
Dim Y2 As Single

    If Link = 0 Then Exit Sub
    If Links(Link).Status And DELETED Then Exit Sub
    G1 = Links(Link).G1
    G2 = Links(Link).G2
    N1 = Links(Link).N1
    N2 = Links(Link).N2
    
    X1 = (Groups(G1).DX + Groups(G1).Nodes(N1).X1) ' * KZoom
    Y1 = (Groups(G1).DY + Groups(G1).Nodes(N1).Y1) ' * KZoom
    X2 = (Groups(G2).DX + Groups(G2).Nodes(N2).X1) ' * KZoom
    Y2 = (Groups(G2).DY + Groups(G2).Nodes(N2).Y1) ' * KZoom
    
    Form1.P1.DrawMode = 13
    Form1.P1.DrawWidth = 5
    Form1.P1.Line (X1, Y1)-(X2, Y2), SelColor   'A larger "unvisible" selectable area
    Form1.P1.DrawWidth = 1
    Form1.P1.Line (X1, Y1)-(X2, Y2), Color      'The link itself
End Sub

Public Sub DrawLinksA(Color As Long, SelColor As Long)
Dim I As Integer

    For I = 1 To LinksCount
        DrawLinkA I, Color, SelColor
    Next I
End Sub
Public Sub DrawNodes()
Dim C As Long
Dim DM As Integer
Dim DW As Integer
Dim G As Integer
Dim N As Integer
Dim DX As Single
Dim DY As Single

    If GroupsCount < 1 Then Exit Sub
    DM = Form1.P1.DrawMode
    DW = Form1.P1.DrawWidth
    Form1.P1.DrawMode = 13
    Form1.P1.DrawWidth = 6
    C = RGB(0, 0, 255)
    For G = 1 To GroupsCount
        DX = Groups(G).DX
        DY = Groups(G).DY
        If Groups(G).NodesCount > 0 Then
            For N = 1 To Groups(G).NodesCount
                Form1.P1.PSet (Groups(G).Nodes(N).X1 + DX, Groups(G).Nodes(N).Y1 + DY), C
            Next
        End If
    Next
    Form1.P1.DrawMode = DM  'As there was on enter.
    Form1.P1.DrawWidth = DW
End Sub

Public Function NewGroup() As Integer
'Instanciate a new group to receive things
Dim Gid As Integer

    If FreeGidsCount > 0 Then  'recycle a freed id
        Gid = FreeGids(FreeGidsCount)
        FreeGidsCount = FreeGidsCount - 1
    Else
        GroupsCount = GroupsCount + 1
        If GroupsCount > UBound(Groups) Then ReDim Preserve Groups(GroupsCount + 10)               'Allocate and instanciate a new group
        Gid = GroupsCount
    End If
    With Groups(Gid)
        .Status = 0
        .DX = 0
        .DY = 0
        .ThingsCount = 0
        ReDim .Things(0)    'Create internal arrays
        .NodesCount = 0
        ReDim .Nodes(0)
    End With
    NewGroup = Gid
End Function

Public Function ClearGroup(G As Integer)
'Clean up this group i.e. remove any content

    With Groups(G)
        .Status = 0
        .DX = 0
        .DY = 0
        .ThingsCount = 0
        ReDim .Things(0)    'Empty internal arrays
        .NodesCount = 0
        ReDim .Nodes(0)
    End With
End Function
Public Function NewArc(Thick As Single, Color As Long, CX As Single, CY As Single, R As Single, ArcS As Single, ArcE As Single, Aspect As Single) As Integer

    If ThingsCount = 0 Then ReDim Things(10)
    ThingsCount = ThingsCount + 1
    If ThingsCount > UBound(Things) Then ReDim Preserve Things(ThingsCount + 10) 'Add 10 entries at a time
    With Things(ThingsCount)
        .What = "A"
        .BegX = (CX + OX) / KZoom
        .BegY = (CY + OY) / KZoom
        .EndX = R / KZoom
        .ArcS = ArcS
        .ArcE = ArcE
        .EndY = Aspect
        .T = Thick
        .Color = Color
    End With
    NewArc = ThingsCount
    DrawThing NewArc, 13
End Function

Private Function ZOX(X As Single) As Single 'Take care of current zoom factor and offset

    ZOX = X * KZoom - OX
End Function

Private Function ZOY(Y As Single) As Single

    ZOY = Y * KZoom - OY
End Function

Public Sub DrawThing(Gid As Integer, Tid As Integer, DM As Integer, Optional DX As Single = 0, Optional DY As Single = 0)
Dim D As Integer
Dim S As String
Dim I As Integer
Dim X As Single
Dim Y As Single
Dim FC As Long
Dim SC As Long  'Color when selected
        
'        If IsDeleted(Gid, Tid) Then Exit Sub
'        If IsHidden(Gid, Tid) Then Exit Sub
        D = Form1.P1.DrawMode
        Form1.P1.DrawMode = 13
        With Groups(Gid).Things(Tid)
            Form1.P1.DrawWidth = .T * KZoom
            SC = .Color
'            If IsSelected(Gid, Tid) Then SC = RGB(255, 0, 0)
            Select Case .What
            Case "L"    'Line
                Form1.P1.Line (ZOX(DX + .BegX), ZOY(DY + .BegY))-(ZOX(DX + .EndX), ZOY(DY + .EndY)), SC  '.Color
            Case "R"    'Rectangle
                Form1.P1.Line (ZOX(DX + .BegX), ZOY(DY + .BegY))-(ZOX(DX + .EndX), ZOY(DY + .EndY)), SC, B
                '''' Draw centered text if any
                If Len(.Txt) Then
                    If .BegX < .EndX Then 'Find the left most location
                        Form1.P1.CurrentX = ZOX(DX + .BegX)
                    Else
                        Form1.P1.CurrentX = ZOY(DX + .EndX)
                    End If
                    X = Form1.P1.CurrentX      'Copy that loc for multi lines centering
                    If .BegY < .EndY Then
                        Form1.P1.CurrentY = ZOY(DY + .BegY)
                    Else
                        Form1.P1.CurrentY = ZOY(DY + .EndY)
                    End If
'                    Form1.P1.FontSize = .T * KZoom * 4
                    Form1.P1.FontSize = .T * ScaleText * 4
                    FC = Form1.P1.ForeColor
                    Form1.P1.ForeColor = SC 'Use color of the container
                    I = 1
                    S = Substring(.Txt, I, "")
                    While Len(S)
                        Form1.P1.CurrentX = X + Abs(KZoom * (.EndX - .BegX) - Form1.P1.TextWidth(S)) / 2 'CurrentX may have moved, refer to its copy
                        Form1.P1.Print S
                        I = I + 1
                        S = Substring(.Txt, I, "")
                    Wend
                    Form1.P1.ForeColor = FC
                End If
            Case "P"    'Point
                    Form1.P1.DrawWidth = Form1.P1.DrawWidth * 3
                    Form1.P1.PSet ((DX + .BegX) * KZoom - OX, (DY + .BegY) * KZoom - OY), SC    '.Color
                    Form1.P1.DrawWidth = Form1.P1.DrawWidth / 3
            Case "A"    'Arc
                Form1.P1.Circle ((DX + .BegX) * KZoom - OX, (DY + .BegY) * KZoom - OY), .EndX * KZoom, SC, .ArcS, .ArcE, .EndY
            Case "T", "TB"  'Text or Text in box
                    FC = Form1.P1.ForeColor
                    Form1.P1.ForeColor = SC
                    Form1.P1.CurrentX = (DX + .BegX) * KZoom - OX
                    X = Form1.P1.CurrentX
                    Form1.P1.CurrentY = (DY + .BegY) * KZoom - OY
                    Y = Form1.P1.CurrentY
'                    Form1.P1.FontSize = .T * KZoom * 4
                    Form1.P1.FontSize = .T * ScaleText * 4
                    Form1.P1.Print .Txt
                    If .What = "TB" Then    'Add a box aroung
                        Form1.P1.Line (X - 20 * .T * KZoom, Y)-(X + Form1.P1.TextWidth(.Txt) + 20 * .T * KZoom, Y + Form1.P1.TextHeight(.Txt)), SC, B
                        'Make it selectable
                        SetSa Gid, 0, Form1.P1.TextWidth(.Txt), 0, Form1.P1.TextHeight(.Txt)
                    End If
            End Select
        End With
        Form1.P1.DrawMode = D  'current mode
End Sub
Public Sub PrintThings()
Dim Id As Integer

    For Id = 1 To ThingsCount
        PrintThing Id, 13
    Next
End Sub

Public Sub PrintThing(Id As Integer, DM As Integer, Optional DX As Integer = 0, Optional DY As Integer = 0)
Dim T As Thing
Dim D As Integer
Dim S As String
Dim I As Integer
Dim X As Single
Dim Y As Single
Dim FC As Long
    
    If Id > 0 And Id <= ThingsCount Then
        T = Things(Id)
'        D = Form1.P1.DrawMode
        Printer.DrawMode = 13
        With T
            Printer.DrawWidth = .T * KZoom
            Select Case .What
            Case "L"
                If .BegX >= 0 Then Printer.Line (ZOX(DX + .BegX), ZOY(DY + .BegY))-(ZOX(DX + .EndX), ZOY(DY + .EndY)), .Color
            Case "R"
                If .BegX >= 0 Then Printer.Line (ZOX(DX + .BegX), ZOY(DY + .BegY))-(ZOX(DX + .EndX), ZOY(DY + .EndY)), .Color, B
                '''' Draw centered text if any
                If Len(.Txt) Then
                    If .BegX < .EndX Then 'Find the left most location
                        Printer.CurrentX = ZOX(DX + .BegX)
                    Else
                        Printer.CurrentX = ZOY(DX + .EndX)
                    End If
                    X = Printer.CurrentX      'Copy that loc for multi lines centering
                    If .BegY < .EndY Then
                        Printer.CurrentY = ZOY(DY + .BegY)
                    Else
                        Printer.CurrentY = ZOY(DY + .EndY)
                    End If
                    Printer.FontSize = .T * KZoom * 6
                    FC = Printer.ForeColor
                    Printer.ForeColor = .Color 'Use color of the container
                    I = 1
                    S = Substring(.Txt, I, "")
                    While Len(S)
                        Printer.CurrentX = X + Abs(KZoom * (.EndX - .BegX) - Printer.TextWidth(S)) / 2 'CurrentX may have moved, refer to its copy
                        Printer.Print S
                        I = I + 1
                        S = Substring(.Txt, I, "")
                    Wend
                    Printer.ForeColor = FC
                End If
            Case "P"
                If .BegX >= 0 Then
                    Printer.DrawWidth = Printer.DrawWidth * 10
                    Printer.PSet ((DX + .BegX) * KZoom - OX, (DY + .BegY) * KZoom - OY), .Color
                    Printer.DrawWidth = Printer.DrawWidth / 10
                End If
            Case "A"
                If .BegX >= 0 Then Printer.Circle ((DX + .BegX) * KZoom - OX, (DY + .BegY) * KZoom - OY), .EndX * KZoom, .Color, .ArcS, .ArcE, .EndY
            Case "T", "TB"
                If .BegX >= 0 Then
                    Printer.CurrentX = (DX + .BegX) * KZoom - OX
                    X = Printer.CurrentX
                    Printer.CurrentY = (DY + .BegY) * KZoom - OY
                    Y = Printer.CurrentY
                    Printer.FontSize = .T * KZoom * 6
                    Printer.Print .Txt
                    If .What = "TB" Then    'Add a box aroung
                        Printer.Line (X - 20 * .T * KZoom, Y)-(X + Printer.TextWidth(.Txt) + 20 * .T * KZoom, Y + Printer.TextHeight(.Txt)), .Color, B
                    End If
                End If
            End Select
        End With
    End If
End Sub

Public Sub DrawGroups()
Dim Gid As Integer
Dim Tid As Integer

    For Gid = 1 To GroupsCount
        If (Groups(Gid).Status And DELETED) <> DELETED Then
            For Tid = 1 To Groups(Gid).ThingsCount
                DrawThing Gid, Tid, 13, Groups(Gid).DX, Groups(Gid).DY
            Next
        End If
    Next
    RebuildSAs
End Sub

Public Sub DrawGroup(Gid As Integer, Optional DM As Integer = 13, Optional DX As Integer = 0, Optional DY As Integer = 0)
Dim Tid As Integer

    With Groups(Gid)
        If Groups(Gid).Status And DELETED Then Exit Sub
        For Tid = 1 To .ThingsCount
            DrawThing Gid, Tid, DM, .DX, .DY
        Next
    End With
End Sub

Public Sub ShowThing(Gid As Integer, Id As Integer, Optional DX As Integer = 0, Optional DY As Integer = 0)
Dim T As Thing
Dim FC As Long
    
    With Groups(Gid).Things(Id)
            Select Case .What
            Case "L"
                If .BegX >= 0 Then Form1.P1.Line ((DX + .BegX) * KZoom - OX, (DY + .BegY) * KZoom - OY)-((DX + .EndX) * KZoom - OX, (DY + .EndY) * KZoom - OY), .Color Xor RGB(0, 255, 0)
            Case "R"
                If .BegX >= 0 Then Form1.P1.Line ((DX + .BegX) * KZoom - OX, (DY + .BegY) * KZoom - OY)-((DX + .EndX) * KZoom - OX, (DY + .EndY) * KZoom - OY), .Color Xor RGB(0, 255, 0), B
            Case "A"
                If .BegX >= 0 Then Form1.P1.Circle (.BegX * KZoom - OX, .BegY * KZoom - OY), .EndX * KZoom, .Color Xor RGB(0, 255, 0), .ArcS, .ArcE, .EndY
            Case "T"
                If .BegX >= 0 Then
                    Form1.P1.CurrentX = (DX + .BegX) * KZoom - OX
                    Form1.P1.CurrentY = (DY + .BegY) * KZoom - OY
                    Form1.P1.FontSize = .T * KZoom
                    FC = Form1.P1.ForeColor
                    Form1.P1.ForeColor = RGB(255, 0, 255)
                    Form1.P1.Print .Txt
                    Form1.P1.ForeColor = FC
                End If
            End Select
        End With
End Sub

Public Sub LightOn(G As Integer)
'Light the SA zone of the specified G
Dim D As Integer

    If G = 0 Then Exit Sub
    D = Form1.P1.DrawMode
    Form1.P1.DrawMode = 7   'xor
    With Groups(G).SA
    Form1.P1.Line (.X1 * KZoom, .Y1 * KZoom)-(.X2 * KZoom, .Y2 * KZoom), RGB(80, 0, 40), BF
    End With
    Form1.P1.DrawMode = D
End Sub

Public Sub LightOff(G As Integer)
'Light the SA zone of the specified G
Dim D As Integer

    If G = 0 Then Exit Sub
    D = Form1.P1.DrawMode
    Form1.P1.DrawMode = 7   'xor
    With Groups(G).SA
    Form1.P1.Line (.X1 * KZoom, .Y1 * KZoom)-(.X2 * KZoom, .Y2 * KZoom), RGB(80, 0, 40), BF
    End With
    Form1.P1.DrawMode = D
End Sub

Public Sub DrawLink(L As Integer)

Dim X1 As Single
Dim X2 As Single
Dim Y1 As Single
Dim Y2 As Single

    X1 = Links(L).X1
    X2 = Links(L).X2
    Y1 = Links(L).Y1
    Y2 = Links(L).Y2
    NewThing "L", 1, RGB(255, 0, 0), X1, Y1, X2, Y2, "", 0
End Sub
Public Sub DrawLinks()
Dim I As Integer

    If LinksCount = 0 Then Exit Sub
    For I = 1 To LinksCount
        DrawLink I
    Next
End Sub

Public Function FindPointedGroup(X As Single, Y As Single) As Integer
' Returns the gid of the group under the mouse or 0 if not

Dim G As Integer

    FindPointedGroup = 0
    For G = 1 To GroupsCount
        If X > Groups(G).SA.X1 Then 'possible
            If X < Groups(G).SA.X2 Then
                If Y > Groups(G).SA.Y1 Then
                    If Y < Groups(G).SA.Y2 Then 'Found
                        FindPointedGroup = G
                        Exit Function
                    End If
                End If
            End If
        End If
    Next
End Function

Public Function FindSaId(X As Single, Y As Single) As Integer

    If SasCount = 0 Then Exit Function
    For FindSaId = 1 To SasCount
        If X > Sas(FindSaId).A.X1 Then
            If X < Sas(FindSaId).A.X2 Then
                If Y > Sas(FindSaId).A.Y1 Then
                    If Y < Sas(FindSaId).A.Y2 Then Exit Function
                End If
            End If
        End If
    Next
    FindSaId = 0
End Function

Public Sub Light(SaId As Integer)
Dim D As Integer
    
    If SaId = 0 Then Exit Sub
    D = Form1.P1.DrawMode
    Form1.P1.DrawMode = 7
    With Sas(SaId).A
        Form1.P1.Line (.X1, .Y1)-(.X2, .Y2), RGB(0, 128, 128), BF
    End With
    Form1.P1.DrawMode = D
End Sub

Private Sub ThingToGrid(Gid As Integer, Tid As Integer)

    With Groups(Gid).Things(Tid)
        .BegX = SnapToGrid(.BegX)
        .BegY = SnapToGrid(.BegY)
        If .What <> "A" Then
            .EndX = SnapToGrid(.EndX)
            .EndY = SnapToGrid(.EndY)
        End If
    End With
End Sub

Public Sub ThingsToGrid()
Dim Gid As Integer
Dim Tid As Integer

    For Gid = 0 To GroupsCount
        For Tid = 1 To Groups(Gid).ThingsCount
            ThingToGrid Gid, Tid
            DrawThing Gid, Tid, 13
        Next
    Next
'    DrawThing
End Sub

Public Function SnapToGrid(V As Single) As Single
'Always snap, grid being visible or not
    
    SnapToGrid = (V \ (GridPitch * KZoom)) * (GridPitch * KZoom)  'Rounding to
    If V Mod (GridPitch * KZoom) > GridPitch * KZoom / 2 Then SnapToGrid = SnapToGrid + GridPitch * KZoom
End Function
Public Sub MoveGroup(Gid As Integer, X As Single, Y As Single)
'Change coordinates of all things in the group G

Dim G As Group  'Try a static ?
Dim Tid As Integer    'Thing id
Dim S As String

    If Gid = 0 Then Exit Sub
    X = SnapToGrid(X)
    Y = SnapToGrid(Y)
    G = Groups(Gid)     'Can be read but not writen ?? bugabillou ?? Should be declared as static ??
    If Groups(Gid).ThingsCount = 0 Then Exit Sub
    For Tid = 1 To Groups(Gid).ThingsCount
'        With G.Things(Tid)
            Groups(Gid).Things(Tid).EndX = G.Things(Tid).EndX - G.Things(Tid).BegX + X
            Groups(Gid).Things(Tid).EndY = G.Things(Tid).EndY - G.Things(Tid).BegY + Y
            Groups(Gid).Things(Tid).BegX = X
            Groups(Gid).Things(Tid).BegY = Y
            Groups(Gid).Things(Tid).NodeX = X
            Groups(Gid).Things(Tid).NodeY = Y
'            S = G.Things(Tid).Txt
'        End With
    Next
    Form1.P1.Cls
    DrawGroups
End Sub

Public Sub MoveGroupA(Gid As Integer, X As Single, Y As Single)

    If Gid = 0 Then Exit Sub
'    X = SnapToGrid(X)
'    Y = SnapToGrid(Y)
    With Groups(Gid)
        .DX = .DX + X
        .DY = .DY + Y
'        .SA.X1 = .SA.X1 + X
'        .SA.X2 = .SA.X2 + X
'        .SA.Y1 = .SA.Y1 + Y
'        .SA.Y2 = .SA.Y2 + Y
    End With
'    If Gid = 1 Then
'        XX = X
'        YY = Y
'    End If
End Sub

Public Sub MoveThings(StepH As Single, StepV As Single, Optional Status As Integer = 0)
'Erase, move and redraw (possibly in XOR mode) Text does not support XOR . . .
'Steps may be positive (to right or down) or negative (to left or up)
'No longer use DX nor DY
Dim Gid As Integer
Dim Tid As Integer

    For Gid = 0 To GroupsCount
        For Tid = 1 To Groups(Gid).ThingsCount
            With Groups(Gid).Things(Tid)
                If Status = 0 Or .Status And Status Then
'                If IsSelected(Gid, Tid) Then
                    .BegY = .BegY + StepV
                    .BegX = .BegX + StepH
                    If .What <> "A" Then
                        .EndX = .EndX + StepH
                        .EndY = .EndY + StepV
                    End If
                End If
            End With
        Next
    Next
End Sub

Public Sub DeleteSelected()
Dim Gid As Integer
Dim Tid As Integer

    For Gid = 0 To GroupsCount
        For Tid = 1 To Groups(Gid).ThingsCount
            With Groups(Gid).Things(Tid)
                If IsSelected(Gid, Tid) Then SetStatus Gid, Tid, DELETED
            End With
        Next
    Next
    Form1.P1Redraw
End Sub

Public Sub DeleteLast()
Dim Gid As Integer
    
    Gid = GroupsCount
    SetStatus Gid, Groups(Gid).ThingsCount, DELETED
    Form1.P1Redraw
End Sub

Public Sub DeleteGroup(G As Integer)
Dim L As Integer

    If G > GroupsCount Or G = 0 Then Exit Sub
    Groups(G).ThingsCount = 0
    ReDim Groups(G).Things(0) ' Free some memory
    Groups(G).NodesCount = 0
    ReDim Groups(G).Nodes(0)
    For L = 1 To LinksCount
        If (Links(L).G1 = G) Or (Links(L).G2 = G) Then DeleteLink L
    Next
    FreeGidsCount = FreeGidsCount + 1
    If FreeGidsCount > UBound(FreeGids) Then ReDim Preserve FreeGids(FreeGidsCount + 10)
    FreeGids(FreeGidsCount) = G     'recyclable
    Groups(G).Status = DELETED    'Mark as deleted
End Sub

Public Sub DeleteThing(T As Integer)

End Sub

Public Sub DeleteNode(N As Integer)

End Sub

Public Sub DeleteLink(L As Integer)
    If L > LinksCount Or L = 0 Then Exit Sub
    FreeLidsCount = FreeLidsCount + 1
    If FreeLidsCount > UBound(FreeLids) Then ReDim Preserve FreeLids(FreeLidsCount + 10)
    FreeLids(FreeLidsCount) = L
    Links(L).Status = DELETED
End Sub

Public Sub GroupSelected() 'Copy (duplicate) selected things in a new group
Dim NewGid As Integer
Dim Tid As Integer
Dim Gid As Integer
    
    NewGid = NewGroup   'Obtain a new group ... only once !
    For Gid = 0 To GroupsCount - 1  'Void self copy
        For Tid = 1 To Groups(Gid).ThingsCount
            If IsSelected(Gid, Tid) Then
                With Groups(NewGid)
                'Instanciate a new thing
'                Groups(NewGid).Thing = Groups(Gid).Things
                    .ThingsCount = .ThingsCount + 1
                    If .ThingsCount > UBound(.Things) Then ReDim Preserve .Things(.ThingsCount + 10)    'Obtain some room
'                    .Things(.ThingsCount) = Groups(Gid).Things(Tid) 'Copy here
                    CopyThing Gid, Tid, NewGid, .ThingsCount
                End With
            End If
        Next
    Next
    Form1.P1Redraw
End Sub

Public Sub CopyThing(FromGroup As Integer, FromThing As Integer, ToGroup As Integer, ToThing As Integer, Optional Status As Integer = 0)
'Copy values from a thing to another one and set its status

    With Groups(FromGroup).Things(FromThing)
        Groups(ToGroup).Things(ToThing).ArcE = .ArcE
        Groups(ToGroup).Things(ToThing).ArcS = .ArcS
        Groups(ToGroup).Things(ToThing).BegX = .BegX
        Groups(ToGroup).Things(ToThing).BegY = .BegY
        Groups(ToGroup).Things(ToThing).Color = .Color
        Groups(ToGroup).Things(ToThing).EndX = .EndX
        Groups(ToGroup).Things(ToThing).EndY = .EndY
        Groups(ToGroup).Things(ToThing).Fill = .Fill
        Groups(ToGroup).Things(ToThing).Next = .Next
        Groups(ToGroup).Things(ToThing).Prev = .Prev
        Groups(ToGroup).Things(ToThing).Status = Status   'Forced
        Groups(ToGroup).Things(ToThing).T = .T
        Groups(ToGroup).Things(ToThing).Txt = .Txt
        Groups(ToGroup).Things(ToThing).What = .What
    End With
    
End Sub

Public Sub CopyGroup(GS As Integer, GD As Integer, X As Single, Y As Single)
'Duplicate GS as GD at a specified location
Dim I As Integer

    If GS = 0 Or GD = 0 Then Exit Sub
    With Groups(GD)
        .DX = X
        .DY = Y
        .SA.X1 = Groups(GS).SA.X1
        .SA.X2 = Groups(GS).SA.X2
        .SA.Y1 = Groups(GS).SA.Y1
        .SA.Y2 = Groups(GS).SA.Y2
        .Status = Groups(GS).Status
        .ThingsCount = Groups(GS).ThingsCount
        ReDim .Things(.ThingsCount)
        For I = 1 To .ThingsCount
            .Things(I).What = Groups(GS).Things(I).What
            .Things(I).T = Groups(GS).Things(I).T
            .Things(I).BegX = Groups(GS).Things(I).BegX
            .Things(I).BegY = Groups(GS).Things(I).BegY
            .Things(I).EndX = Groups(GS).Things(I).EndX
            .Things(I).EndY = Groups(GS).Things(I).EndY
            .Things(I).ArcS = Groups(GS).Things(I).ArcS
            .Things(I).ArcE = Groups(GS).Things(I).ArcE
            .Things(I).Color = Groups(GS).Things(I).Color
            .Things(I).Txt = Groups(GS).Things(I).Txt
            .Things(I).Status = Groups(GS).Things(I).Status
        Next
        .NodesCount = Groups(GS).NodesCount
        ReDim .Nodes(.NodesCount)
        For I = 1 To .NodesCount
            .Nodes(I).Id = Groups(GS).Nodes(I).Id
            .Nodes(I).X1 = Groups(GS).Nodes(I).X1
            .Nodes(I).X2 = Groups(GS).Nodes(I).X2
            .Nodes(I).Y1 = Groups(GS).Nodes(I).Y1
            .Nodes(I).Y2 = Groups(GS).Nodes(I).Y2
        Next
    End With
End Sub

Public Sub SetSa(G As Integer, X1 As Single, X2 As Single, Y1 As Single, Y2 As Single)
' Set relative selectable area for that group

    If G = 0 Then Exit Sub
    With Groups(G)
        If X2 > X1 Then
            .SA.X1 = X1
            .SA.X2 = X2
        Else
            .SA.X1 = X2
            .SA.X2 = X1
        End If
        If Y2 > Y1 Then
            .SA.Y1 = Y1
            .SA.Y2 = Y2
        Else
            .SA.Y1 = Y2
            .SA.Y2 = Y1
        End If
        .SA.Id = 1
    End With
End Sub

Public Sub RebuildSAs()
'Sas lists all select area.
'Used to fast search when mouse move.
Dim G As Integer
Dim T As Integer
Dim N As Integer
Dim X As Integer

    ReDim Sas(0)    'destroy previus
    SasCount = 0
    If GroupsCount = 0 Then Exit Sub
    For G = 1 To GroupsCount    'scan all groups
        If Groups(G).Status = 0 Then    'not deleted
            With Groups(G).SA
                If .Id > 0 Then     'Selectable group, add it
                    SasCount = SasCount + 1
                    If SasCount > UBound(Sas) Then ReDim Preserve Sas(SasCount + 10)    'Add some room
                    Sas(SasCount).G = G
                    Sas(SasCount).T = 0
                    Sas(SasCount).A = Groups(G).SA      'Copy coordinates
                    Sas(SasCount).A.X1 = Sas(SasCount).A.X1 + Groups(G).DX   'Make'em absolute
                    Sas(SasCount).A.X2 = Sas(SasCount).A.X2 + Groups(G).DX
                    Sas(SasCount).A.Y1 = Sas(SasCount).A.Y1 + Groups(G).DY
                    Sas(SasCount).A.Y2 = Sas(SasCount).A.Y2 + Groups(G).DY
                End If
                X = Groups(G).NodesCount
                If X > 0 Then    'There are X nodes in this group
                    If SasCount + X > UBound(Sas) Then ReDim Preserve Sas(SasCount + X + 10) 'Insure enough room
                    For N = 1 To X  'for each node in this group
                        SasCount = SasCount + 1
                        Sas(SasCount).G = G     'Fill the record
                        Sas(SasCount).N = N
                        Sas(SasCount).T = 1
                        Sas(SasCount).A.X1 = Groups(G).Nodes(N).X1 + Groups(G).DX - 100  'Extend area to make selection easier
                        Sas(SasCount).A.X2 = Groups(G).Nodes(N).X2 + Groups(G).DX + 100
                        Sas(SasCount).A.Y1 = Groups(G).Nodes(N).Y1 + Groups(G).DY - 100
                        Sas(SasCount).A.Y2 = Groups(G).Nodes(N).Y2 + Groups(G).DY + 100
                    Next
                End If
            End With
        End If
    Next
'    Debug.Print "sascount", SasCount
'    ShowSas
End Sub

Public Sub ShowSas()
'To debug routine above
Dim I As Integer
Dim N As Integer


    If SasCount = 0 Then Exit Sub   'Nothing
    For I = 1 To SasCount
        With Sas(I)
            If Groups(.G).SA.Id > 0 Then Drawrectangle .A, 0
            If Groups(.G).NodesCount > 0 Then
                If .N > 0 Then Drawrectangle .A, 0
            End If
        End With
    Next
End Sub

Public Sub Drawrectangle(A As CXY, W As Single)

    Form1.P1.Line (A.X1 - W, A.Y1 - W)-(A.X2 + W, A.Y2 + W), RGB(128, 128, 128), BF
    
End Sub

Public Function GetNodes()

End Function
